%% Ejemplo 15: Medida de calidad de una imagen

% Lectura de una imagen
I=imread('peppers.png');
ImagInfo=imfinfo('peppers.png');
fprintf('\n peppers.png size=%d bytes',ImagInfo.FileSize); 

% Conversin a JPEG
imwrite(I,'peppers15.jpg','quality',15);

% Medidas de calidad de las imgenes
ImagInfo=imfinfo('peppers15.jpg'); %Informacin de la imagen
Ijpg=imread('peppers15.jpg'); % Lectura de la imagen en formato jpeg

% Calculo medida calidad
[PSNR MSE E] = errorMedida(I, Ijpg); 
fprintf('\n peppers15.jpg size=%d bytes PSNR=%f dB dB MSE=%f',ImagInfo.FileSize, PSNR, MSE); 

% Visualizacin de las imgenes
subplot(2,2,1), imshow(I),title('IMAGEN ORIGINAL');
subplot(2,2,2), imshow(Ijpg),title('IMAGEN COMPRIMIDA');
subplot(2,2,3), imshow(abs(I-Ijpg),[]),title('IMAGEN DIFERENCIA');
subplot(2,2,4), imshow(log(1+abs(double(I-Ijpg)))),title('IMAGEN DIFERENCIA LOG');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                              %%
%% COMPRESION DE VIDEO                                          %%
%% Grado en Ingeniera de Tecnologas de Telecomunicacin       %%
%% Gustavo A. Ruiz Robredo                                      %%
%% ruizrg@unican.es                                             %%
%%                                                              %%
%% uu   uu  cccccc   UNIVERSIDAD DE CANTABRIA                   %%
%% uu   uu  cccccc   Dpto. INGENIERIA INFORMATICA Y ELECTRONICA %%
%% uu   uu  cc       FACULTAD DE CIENCIAS                       %%
%%  uuuuu   cccccc   Avda. Los Castros s/n                      %%
%%   uuu    cccccc   39005-SANTANDER (SPAIN)                    %%
%%                                                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%