%% Ejemplo 9: Operaciones de filtrado

% Se ee una imagen
I=imread('peppers.png');

% Definicin de diferentes mscaras
f1=1/9*[1 1 1; 1 1 1; 1 1 1]; % Mscara de desenfoque
f2=[0 -1 0; -1 5 -1; 0 -1 0]; % Mscara de enfoque
f3=[1 1 1; 1 -8 1; 1 1 1]; % Laplaciana
f4=[-1 -2 -1; 0 0 0 ; 1 2 1]; % Mscara de bordes Vertical
f5=transpose(f4); % Mscara de bordes Horizontal

% Filtrado aplicando las mscaras anteriores
I1=imfilter(I,f1);
I2=imfilter(I,f2);
I3=imfilter(I,f3);
I4=imfilter(I,f4);
I5=imfilter(I,f5);

% Visualizacin de las imgenes
subplot(3,2,1), imshow(I), title('ORIGINAL');
subplot(3,2,2), imshow(I1), title('Desenfoque');
subplot(3,2,3), imshow(I2), title('Enfoque');
subplot(3,2,4), imshow(I3), title('Laplaciana');
subplot(3,2,5), imshow(I4), title('Borde Vertical');
subplot(3,2,6), imshow(I5), title('Borde Horizontal');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                              %%
%% COMPRESION DE VIDEO                                          %%
%% Grado en Ingeniera de Tecnologas de Telecomunicacin       %%
%% Gustavo A. Ruiz Robredo                                      %%
%% ruizrg@unican.es                                             %%
%%                                                              %%
%% uu   uu  cccccc   UNIVERSIDAD DE CANTABRIA                   %%
%% uu   uu  cccccc   Dpto. INGENIERIA INFORMATICA Y ELECTRONICA %%
%% uu   uu  cc       FACULTAD DE CIENCIAS                       %%
%%  uuuuu   cccccc   Avda. Los Castros s/n                      %%
%%   uuu    cccccc   39005-SANTANDER (SPAIN)                    %%
%%                                                              %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%